#include <stdio.h>
#include <stdlib.h>
#include "Automaton.h"
#ifdef PROTOS_NEEDED
#include "AddWord.h"
#endif


DAGElement *Automaton=NULL ;
ULONG AutomatonSize ;
ULONG InitialState=END_TRANSITION ;




void main (argc, argv)
	int argc ;
	char *argv[] ;

{
  FILE *InHd=NULL ;
  FILE *OutHd=NULL ;
  UBYTE WordToAdd[MAX_WORD_LEN] ;
  ULONG Magic ;


  fprintf (stderr, "AddWord by Franois PESSAUX (c) 1995.\n") ;
  if (argc != 3)
    {
      printf ("Parameter error. Usage: AddWord <DicFileSrc> <DicFileDest>.\n");
      printf ("DicFileSrc must be the name of an ALREADY EXISTING ") ;
      printf ("dictionary database\n.");
      printf ("DicFileDest must be the name of the new dictionary created ") ;
      printf ("by adding the words to DicFileSrc.\n") ;
      exit (0) ;
    }

  InHd = (FILE*) fopen (argv[1], "r") ;
  if (InHd == NULL)
    {
      printf ("Reading error.\n") ;
      printf ("Can't open the input dictionary file '%s'for reading.\n",
	      argv[1]) ;
      exit (0) ;
    }

  fread (&Magic, 1, sizeof (ULONG), InHd) ;
  if (Magic != TABLEMAGICNUMBER)
    {
      printf ("Format error. Input file '%s' isn't a dictionary file.\n",
	      argv[1]) ;
      fclose (InHd) ;
      exit (0) ;
    }

  fread (&AutomatonSize, 1, sizeof (ULONG), InHd) ;
  fread (&InitialState, 1, sizeof (ULONG), InHd) ;
  Automaton = (DAGElement*) malloc (AutomatonSize*sizeof (DAGElement)) ;
  if (Automaton == NULL)
    {
      /* ALLOCATION FOIREE */
      printf ("Insufficient memory.\n") ;
      printf ("Requiered memory space : %ld bytes.\n",
	      (AutomatonSize*sizeof (DAGElement))) ;
      fclose (InHd) ;
      exit (0) ;
    }
  fread (Automaton, AutomatonSize, sizeof (DAGElement), InHd) ;
  fclose (InHd) ;


  printf ("Word to add: ") ;
  scanf ("%s", WordToAdd) ;
  while (!feof (stdin))
    {
      AddWord (WordToAdd) ;
      printf ("Word to add: ") ;
      scanf ("%s", WordToAdd) ;
    }

  OutHd = (FILE*) fopen (argv[2], "w") ;
  if (OutHd == NULL)
    {
      printf ("Writing error.\n") ;
      printf ("Can't open the output file '%s' for writing.\n", argv[2]) ;
      free (Automaton) ;
      exit (0) ;
    }


  fwrite (&Magic, 1, sizeof (ULONG), OutHd) ;
  fwrite (&AutomatonSize, 1, sizeof (ULONG), OutHd) ;
  fwrite (&InitialState, 1, sizeof (ULONG), OutHd) ;
  fwrite (Automaton, AutomatonSize, sizeof (DAGElement), OutHd) ;
  
  fclose (OutHd) ;
  free (Automaton) ;
  printf ("\n") ;
  exit (0) ;
}
