#include <string.h>
#include "Automaton.h"
#ifdef PROTOS_NEEDED
#include "AddWord.h"
#include "MakeStates.h"
#endif



extern ULONG InitialState ;
extern ULONG AutomatonSize ;
extern DAGElement *Automaton ;


/* ROUTINE POUR RAJOUTER UN MOT QUI <<N'EXISTAIT PAS DEJA>> DANS LE */
/* DICTIONNAIRE */

void AddWord (Word)
	UBYTE *Word ;

{
  ULONG Parent ;     /* CASE ET NON BASE DE LA DERNIERE TRANSITION */
                     /* C'EST A DIRE QUE CA REPRESENTE DIRECTEMENT LA */
                     /* CASE OU EST STOCKE LA LETTRE ET NON SON OFFSET */
                     /* DE BASE */
  ULONG TmpBase ;
  ULONG Base ;
  DAGElement StatesToCreate[256] ;
  UBYTE TmpChar ;
  UBYTE NbStatesToCreate ;
  UBYTE i ;
  ULONG j ;
  

  Parent = END_TRANSITION ;
  Base = InitialState ;

  for (i=0;i<strlen (Word);i++)
    {
      if (Base == END_TRANSITION) break ;       /* ON VIENT DE QUITTER LE CHEMIN COMMUN */

      TmpChar = GETCHAR (Automaton[Base+Word[i]]) ;
      if (TmpChar != Word[i]) break ;
      if (Base+Word[i]>=AutomatonSize) break ;

      /* ON EST ENCORE SUR UN CHEMIN COMMUN */
      Parent = Base + (ULONG) TmpChar ;
      Base = GETNEXTBASE (Automaton[Base+TmpChar]) ;
    }
  

  /* SI i EST EGAL A strlen (Word) C'EST QUE LE MOT A RAJOUTER EST ENTIEREMENT */
  /* INSCRIT DANS UN CHEMIN DEJA PRESENT */
  /* DANS CE CAS ON LUI FAIT SON SORT TOUT DE SUITE */
  if (i == strlen (Word))
    {
#ifdef DEBUG
      printf ("Mot inclu dans un ancien...\n") ;
#endif
      /* IL FAUT JUSTE POSITIONNER LE BIT DE IsFinal */
      SETISFINAL (Automaton[Parent]) ;
      return ;
    }


  /* Parent == END_TRANSITION => ETAT INITIAL AFFECTE */
  /* Base == END_TRANSITION => RALLONGE D'ETAT FINAL */
  
  if (Base != END_TRANSITION)
    {
      /* CE N'EST PAS UNE RALLONGE */
#ifdef DEBUG
      printf ("Pas une rallonge...\n") ;
#endif
      /* ON REGARDE SI ON A BESOIN D'UNE RELOCATION */
      if ((Base+Word[i] >= AutomatonSize) || (GETCHAR (Automaton[Base+Word[i]])))
	{
	  /* RELOCATION EXIGEE */
#ifdef DEBUG
	  printf ("Rellocation necessitee...\n") ;
#endif
	  NbStatesToCreate = 0 ;
	  for (j=1;j<256;j++)
	    {
	      if (Base+j >= AutomatonSize)
		break ;
	      else
		{
		  if (GETCHAR (Automaton[Base+j]) == (UBYTE) j)
		    {
		      /* ON GARDE L'ETAT A RELOGER */
		      StatesToCreate[NbStatesToCreate] = Automaton[Base+j] ;
		      /* ON RETIRE DANS LE TABLEAU LE BIT DE BASE DE L'ETAT A RELOGER */
		      UNSETISBASE (StatesToCreate[NbStatesToCreate]) ;
		      /* ON VIDE L'ETAT DANS LE DAG A RELOGER */
		      SETCHAR (Automaton[Base+j], '\0') ;
		      UNSETISFINAL (Automaton[Base+j]) ;
		      /* 0 OU END_TRANSITION, N'IMPORTE */
		      SETNEXTBASE (Automaton[Base+j], 0) ;
		      NbStatesToCreate++ ;
		    }
		}
	    }
	  
	  /* ON RAJOUTE DANS LA LISTE DES ETATS A RELOGER L'ETAT QUE L'ON VEUT CREER */
	  CLEARELEM (StatesToCreate[NbStatesToCreate]) ;
	  SETCHAR (StatesToCreate[NbStatesToCreate], Word[i]) ;
	  SETNEXTBASE (StatesToCreate[NbStatesToCreate], END_TRANSITION) ;
	  NbStatesToCreate++ ;
	  
	  /* PUISQUE L'ON RELOGE, CETTE CASE N'EST PLUS UNE BASE !!! */
	  UNSETISBASE (Automaton[Base]) ;
	  
	  TmpBase = MakeStates (StatesToCreate, NbStatesToCreate) ;
	  if (Parent == END_TRANSITION)
	    {
	      /* C'EST LA RACINE QUE L'ON A RELOGE */
	      InitialState = TmpBase ;
	    }
	  else
	    {
	      /* ON A RELOGE UN AUTRE ETAT QUE LA RACINE */
	      SETNEXTBASE (Automaton[Parent], TmpBase) ;
	    }
	  Parent = TmpBase + Word[i] ;	/* OU + TmpChar */
	}
      else
	{
	  /* RELLOCATION NON NECESSITEE */
#ifdef DEBUG
	  printf ("Pas de relocation necesitee...\n") ;
#endif
	  /* ON SE CONTENTE DONC DE RANGER NOTRE ETAT */
	  SETCHAR (Automaton[Base+Word[i]], Word[i]) ;
	  SETNEXTBASE (Automaton[Base+Word[i]],END_TRANSITION) ;
	  /* PAS BESOIN DE DIRE QUE LA BASE EST UNE BASE CAR */
	  /* CA A DEJA ETE FAIT */
	  Parent = Base + Word[i] ;
	}
    }
  else
    {
      /* CAS OU C'EST UNE RALLONGE D'ETAT */
#ifdef DEBUG
      printf ("Rallonge...\n") ;
#endif
      CLEARELEM (StatesToCreate[0]) ;
      /* COMME A PRIORI ON NE SAIT PAS S'IL RESTE D'AUTRES ETATS A CREER DERRIERE */
      /* ON MET LA PROCHAINE TRANSITION A VIDE COMME CA S'IL N'Y A PLUS RIEN, CE */
      /* SERA DEJA FAIT. */
      SETNEXTBASE (StatesToCreate[0], END_TRANSITION) ;
      SETCHAR (StatesToCreate[0], Word[i]) ;
      TmpBase = MakeStates (StatesToCreate, 1) ;
      if (Parent == END_TRANSITION)
	{
	  /* ON RALLONGE L'ETAT INITIAL (LA SOUCHE) */
#ifdef DEBUG
	  printf ("Rallonge de l'etat initial...\n") ;
#endif
	  InitialState = TmpBase ;
	}
      else
	{
#ifdef DEBUG
	  printf ("Rallonge d'un autre l'etat initial que l'initial...\n") ;
#endif
	  /* ON RALLONGE UN AUTRE ETAT QUE LA SOUCHE */
	  SETNEXTBASE (Automaton[Parent], TmpBase) ;
	}
      Parent = TmpBase + Word[i] ;	/* OU + TmpChar */
    }
  
  /* DONC, QUAND ON ARRIVE ICI, SI NECESSAIRE LA RELOCATION OU LA RALLONGE A */
  /* ETE EFFECTUEE */
  /* ON FINI LA CHAINE ET ON MARQUE LE DERNIER ETAT COMME FINAL */
  /* REMARQUE: SI LE MOT S'INSCRIT COMPLETEMENT DANS UN CHEMIN ANCIEN */
  /* CETTE PARTIE SERA SANS EFFET, ON MARQUERA SEULEMENT LE DERNIER ETAT */
  /* COMME FINAL */
  i++ ;
  for (;i<strlen (Word);i++)
    {
      CLEARELEM (StatesToCreate[0]) ;
      /* ON DIT QUE LA TRANSITION SUIVANTE EST INEXISTANTE COMME CA, CA */
      /* SERA FAIT POUR SI C'EST NECESSAIRE POUR LE DERNIER ETAT  CREE */
      /* REM: ON NE LE FAIT PAS DIRECTEMENT TOUT A LA FIN CAR SI ON A */
      /*  RAJOUTE UN MOT DANS UN CHEMIN DEJA EXISTANT ET QUE CE MOT EST */
      /*  PLUS COURT QUE LE MOT DONT IL EMPRUNTE LE CHEMIN, METTRE UN */
      /*  END_TRANSITION A LA FIN COUPERAIT DIRECTEMENT L'ARBRE ET NOUS */
      /*   PRIVERAIT DES MOTS PLUS LONGS DE CE CHEMIN */
      SETNEXTBASE (StatesToCreate[0], END_TRANSITION) ;
      SETCHAR (StatesToCreate[0], Word[i]) ;
      TmpBase = MakeStates (StatesToCreate, 1) ;
      SETNEXTBASE (Automaton[Parent], TmpBase) ;
      Parent = TmpBase + Word[i] ;
    }

#ifdef DEBUG
  printf ("Mot rajoute...\n") ;
#endif
  SETISFINAL (Automaton[Parent]) ;
}
