#ifndef __AUTOMATON__

typedef unsigned long ULONG ;
typedef unsigned char UBYTE ;
typedef unsigned char UCHAR ;
typedef unsigned short UWORD ;
typedef unsigned short USHORT ;
typedef long LONG ;
typedef char CHAR ;
typedef char BYTE ;
typedef short SHORT ;
typedef short WORD ;
typedef unsigned char BOOL ;


#ifndef TRUE
#define FALSE 0
#define TRUE !FALSE
#endif

#define MAX_STACK_SIZE (256*MAX_WORD_LEN+MAX_WORD_LEN)
#define MAX_WORD_LEN 50
#define INITIAL_AUTOMATON_SIZE 5000
#define AUTOMATON_GROW_SIZE 16000

/* DAGElement = ULONG. */
/* Bits 0-7 de poids faible = Char */
/* Bit 8 = IsBase | NextFilled */
/* Bit 9 = IsFinal */
/* Bits 10-31 = NextBase */
typedef ULONG DAGElement ;

#define CLEARELEM(Foo) \
	(Foo = 0L)

#define GETCHAR(Foo) \
	((UBYTE) (Foo & 0xFF))

#define GETISBASE(Foo) \
	(Foo & 0x00000100)

#define GETNEXTFILLED(Foo) \
	(Foo & 0x00000100)

#define GETISFINAL(Foo) \
	(Foo & 0x00000200)

#define GETNEXTBASE(Foo) \
	((ULONG) (Foo >> 10))

#define SETCHAR(Foo,Char) \
	(Foo &= 0xFFFFFF00) ; \
	(Foo |= Char)

#define SETISBASE(Foo) \
	(Foo |= (1L << 8))

#define UNSETISBASE(Foo) \
	(Foo &= 0xFFFFFEFF)

#define SETNEXTFILLED(Foo) \
	(Foo |= (1L << 8))

#define UNSETNEXTFILLED(Foo) \
	(Foo &= 0xFFFFFEFF)

#define SETISFINAL(Foo) \
	(Foo |= (1L << 9))

#define UNSETISFINAL(Foo) \
	(Foo &= 0xFFFFFDFF)

#define SETNEXTBASE(Foo,BaseValue) \
	Foo &= 0x000003FF ; \
	Foo |= ((ULONG) (BaseValue << 10))

/* VALEUR DU <<POINTEUR>> SIGNIFIANT TRANSITION NON EXISTANTE */
#define END_TRANSITION 0x3FFFFF


#define GOOD_LETTER 0
#define BAD_LETTER 1
#define EXCEDENT_LETTER 2
#define FORGOTTEN_LETTER 3
#define FIRST_RUN 4

#define TABLEMAGICNUMBER 0x00FF00FF

#define __AUTOMATON__
#endif
