#include <stdio.h>
#include <stdlib.h>
#include "Automaton.h"
#ifdef PROTOS_NEEDED
#include "ClearAutomMem.h"
#include "MakeAutomaton.h"
#endif


DAGElement *Automaton=NULL ;
ULONG AutomatonSize ;



void main (argc, argv)
	int argc ;
	char *argv[] ;

{
FILE *InHd=NULL ;
FILE *OutHd=NULL ;
ULONG InitialState ;
ULONG Magic = TABLEMAGICNUMBER ;


fprintf (stderr, "BuildTable by Franois PESSAUX (c) 1995.\n") ;
if (argc != 3)
	{
	printf ("Parameter error. Usage: BuildTable <Input> <Output>\n") ;
	printf ("Input MUST be an ASCII text file, alphabeticaly sorted.\n") ;
	printf ("This file MUSTN'T contain the same word twice or more.\n") ;
	printf ("Output is the name of the file where to put the dictionary.\n") ;
	printf ("Try again...\n") ;
	exit (0) ;
	}

/* INITIALISATION DE L'AUTOMATE */
Automaton = (DAGElement*) malloc (INITIAL_AUTOMATON_SIZE*sizeof(DAGElement)) ;
if (Automaton == NULL)
  {
    printf ("Not enought memory. That's the problem !!!\n") ;
    printf ("Sorry, I can't work any more...\n") ;
    exit (0) ;
  }
ClearAutomMem (Automaton, INITIAL_AUTOMATON_SIZE) ;
AutomatonSize = INITIAL_AUTOMATON_SIZE ;

InHd = (FILE*) fopen (argv[1], "r") ;
if (InHd == NULL)
	{
	printf ("Read error.\n") ;
	printf ("I can't open the input file '%s' for reading.\n", argv[1]) ;
	exit (0) ;
	}

OutHd = (FILE*) fopen (argv[2], "w") ;
if (OutHd == NULL)
	{
	printf ("Write error.\n") ;
	printf ("I can't open the output file '%s' for writing.\n", argv[2]) ;
	exit (0) ;
	}

InitialState = MakeAutomaton (InHd) ;

fwrite (&Magic, 1, sizeof (ULONG), OutHd) ;
fwrite (&AutomatonSize, 1, sizeof (ULONG), OutHd) ;
fwrite (&InitialState, 1, sizeof (ULONG), OutHd) ;
fwrite (Automaton, AutomatonSize, sizeof (DAGElement), OutHd) ;

fclose (InHd) ;
fclose (OutHd) ;
free (Automaton) ;

printf ("\nWork is done.\n") ; 
exit (0) ;
}
