#include <stdio.h>
#include <stdlib.h>
#include "Automaton.h"
#ifdef PROTOS_NEEDED
#include "Exists.h"
#endif





DAGElement *Automaton=NULL ;
ULONG AutomatonSize ;


void main (argc, argv)
	int argc ;
	char *argv[] ;

{
FILE *InHd=NULL ;
ULONG InitialState ;
UBYTE WordBuffer[MAX_WORD_LEN] ;
ULONG Magic ;


fprintf (stderr, "CheckWord by Franois PESSAUX (c) 1995.\n") ;
if (argc != 2)
  {
    printf ("Parameter error. Usage: CheckWord <DicFile>\n") ;
    printf ("DicFile must be a dictionary data file.\n") ;
    printf ("Checkword is used in order to know if a word exists ") ;
    printf ("in a given dictionary database. It doesn't give ") ;
    printf ("suggestions.\n") ;
    exit (0) ;
  }

InHd = (FILE*) fopen (argv[1], "r") ;
if (InHd == NULL)
  {
    printf ("Reading error.\n") ;
    printf ("I can't open the dictionary file '%s' for reading.\n", argv[1]) ;
    exit (0) ;
  }

fread (&Magic, 1, sizeof (ULONG), InHd) ;
if (Magic != TABLEMAGICNUMBER)
  {
    printf ("Format error. File '%s' isn't a dictionary file.\n", argv[1]) ;
    fclose (InHd) ;
    exit (0) ;
  }

fread (&AutomatonSize, 1, sizeof (ULONG), InHd) ;
fread (&InitialState, 1, sizeof (ULONG), InHd) ;
Automaton = (DAGElement*) malloc (AutomatonSize*sizeof (DAGElement)) ;
if (Automaton == NULL)
  {
    /* ALLOCATION FOIREE */
    printf ("Insufficient memory.\n") ;
    printf ("Requiered memory space : %ld bytes.\n",
	    (AutomatonSize*sizeof (DAGElement))) ;
    fclose (InHd) ;
    exit (0) ;
  }
fread (Automaton, AutomatonSize, sizeof (DAGElement), InHd) ;
fclose (InHd) ;

printf ("Word to check existence: ") ;
scanf ("%s", WordBuffer) ;
while (!feof (stdin))
  {
    if (Exists (InitialState, WordBuffer))
      printf ("'%s' : Exists\n", WordBuffer) ;
    else
      printf ("'%s' : Doesn't exist\n", WordBuffer) ;
    
    printf ("Word to check existence: ") ;
    scanf ("%s", WordBuffer) ;
  }

free (Automaton) ;
exit (0) ;
}
