#include <stdio.h>
#include <stdlib.h>
#include "Automaton.h"
#ifdef PROTOS_NEEDED
#include "DisplayAutom.h"
#endif


DAGElement *Automaton=NULL ;
ULONG AutomatonSize ;


void main (argc, argv)
	int argc ;
	char *argv[] ;

{
FILE *InHd=NULL ;
ULONG InitialState ;
UBYTE WordBuffer[MAX_WORD_LEN] ;
ULONG Magic ;


fprintf (stderr, "DumpTable by Franois PESSAUX (c) 1995.\n") ;
if (argc != 2)
  {
    printf ("Parameter error. Usage: DumpTable <Dict>\n") ;
    printf ("Dict must be a dictionary database created with BuildTable.\n") ;
    printf ("Dumptable is used to display on the standard output all the ") ;
    printf ("words contained in a dictionary database.\n") ;
    exit (0) ;
  }

InHd = (FILE*) fopen (argv[1], "r") ;
if (InHd == NULL)
  {
    printf ("Reading error.\n") ;
    printf ("Can't open the dictionary file '%s'for reading.\n", argv[1]) ;
    exit (0) ;
  }

fread (&Magic, 1, sizeof (ULONG), InHd) ;
if (Magic != TABLEMAGICNUMBER)
  {
    printf ("Error. File '%s' isn't a dictionary database.\n", argv[1]) ;
    printf ("May be you typed a bad file name...\n") ;
    fclose (InHd) ;
    exit (0) ;
  }

fread (&AutomatonSize, 1, sizeof (ULONG), InHd) ;
fread (&InitialState, 1, sizeof (ULONG), InHd) ;
Automaton = (DAGElement*) malloc (AutomatonSize*sizeof (DAGElement)) ;
if (Automaton == NULL)
  {
    /* ALLOCATION FOIREE */
    printf ("Insufficient memory.\n") ;
    printf ("Requiered memory space : %ld bytes.\n",
	    (AutomatonSize*sizeof (DAGElement))) ;
    fclose (InHd) ;
    exit (0) ;
  }
fread (Automaton, AutomatonSize, sizeof (DAGElement), InHd) ;
fclose (InHd) ;

DisplayAutomaton (InitialState, WordBuffer, 0) ;
free (Automaton) ;
exit (0) ;
}
