#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "Automaton.h"



DAGElement MakeAutomaton (FileHd)
     FILE *FileHd ;

{
  DAGElement *Stack=NULL ;
  ULONG SP ;			   /* POINTE SUR LE DERNIER OCTET UTILISE */
  UBYTE OldWord[MAX_WORD_LEN] ;
  UBYTE CurWord[MAX_WORD_LEN] ;
  UBYTE i ;
  WORD NbLevelsToCreate ;	/* NOMBRE D'ETAGES CREABLES DANS LE DAG */
  UBYTE NbDAGElementsToTake ;   /* NOMBRE DE DAGElements a PRENDRE DANS */
                                /* LE TABLEAU POUR LES CREER */
  ULONG TmpBase ;
  WORD j ;
  ULONG NbWordRead=0 ;


  Stack = (DAGElement*) malloc (MAX_STACK_SIZE*sizeof (DAGElement)) ;
  if (Stack == NULL)
    {
      printf ("I have no memory enought for my internal stack.\n") ;
      printf ("I can't work any more.\n") ;
      exit (0) ;
    }

  SP=0 ;
  CLEARELEM (Stack[SP]) ;
  OldWord[0] = '\0' ;

  while (fscanf (FileHd, "%s", CurWord) > 0)
    {
      if ((NbWordRead % 500) == 0)
	printf ("Processed %ld words\n", NbWordRead) ;
      NbWordRead++ ;

      /* ON A LU UN NOUVEAU MOT DANS LE FLOT D'ENTREE */
      for (i=0;;i++)
	if (CurWord[i] != OldWord[i]) break ;
      /* A LA SORTIE, i POINTE SUR LE CARACTERE QUI FAIT LA PREMIERE */
      /* DIFFERENCE ENTRE LES 2 MOTS (== AU NOMBRE DE CARACTERES */
      /* IDENTIQUES) */

      NbLevelsToCreate = (((WORD) strlen (OldWord)) - ((WORD) i) - 1) ;
      /* SI NbLevelsToCreate < 0 ALORS, IL N'Y A PAS D'ETATS A CREER */
      /* NI DE END_TRANSITION A RAJOUTER AU DERNIER ETAT DE LE PILE */
      /* SI NbLevelsToCreate = 0 ALORS, IL Y A SEULEMENT UN END_TRANSITION */
      /* A RAJOUTER SUR LE DERNIER ETAT DE LA PILE */
      /* SI NbLevelsToCreate >0 ALORS, IL Y A UN END_TRANSITION A RAJOUTER */
      /* SUR LE DERNIER ETAT DE LA PILE, ET NbLevelsToCreate ETAGES A CREER */
      /* DANS LE DAG */
      /* REM: POUR OPTIMISER, ON REUNI NbLevelsToCreate > 0 ET */
      /*      NbLevelsToCreate == 0 en NbLevelsToCreate >= 0 */
      if (NbLevelsToCreate >= 0)
	{
	  SETNEXTBASE (Stack[SP], END_TRANSITION) ;
	  SETNEXTFILLED (Stack[SP]) ;

	  /* ON VA CREER NbLevelstoCreate ETAGES DU DAG */
	  for (j=0;j<NbLevelsToCreate;j++)
	    {
	      /* ON VA REGROUPER TOUTES LES TRANSITIONS DE L'ETAGE */
	      NbDAGElementsToTake = 0 ;
	      while (GETNEXTFILLED (Stack[SP]))
		{
		  /* CE DAGElement A SON CHAMP NEXTBASE FIXE */
		  /* DONC IL VA ETRE VIRTUELLEMENT DEPILE ET TRANSMIS A LA */
		  /* ROUTINE DE CREATION DES ETATS/TRANSITIONS */
		  NbDAGElementsToTake++ ;
		  SP-- ;
		}
	      TmpBase = MakeStates (&Stack[SP+1], NbDAGElementsToTake) ;
	      SETNEXTBASE (Stack[SP], TmpBase) ;
	      SETNEXTFILLED (Stack[SP]) ;
	    }
	}

      /* MAINTENANT, ON VA EMPILER LES NOUVELLES LETTRES DU NOUVEAU MOT */
      for (;i<((UBYTE) strlen(CurWord));i++)
	{
	  SP++ ;
	  CLEARELEM (Stack[SP]) ;
	  SETCHAR (Stack[SP], CurWord[i]) ;
	}

      SETISFINAL (Stack[SP]) ;
      strcpy (OldWord, CurWord) ;
    }

  /* ON N'A PLUS DE MOT A SAISIR, ON VA DONC VIDER LA PILE */
  NbLevelsToCreate = (WORD)strlen (OldWord) ;
  SETNEXTBASE (Stack[SP], END_TRANSITION) ;
  SETNEXTFILLED (Stack[SP]) ;

#ifdef DEBUG
  /* POUR VOIR S'IL Y A UN EVENTUEL PROBLEME */
  if (NbLevelsToCreate == 0)
    {
      printf ("Wizz, Wizz, Wizz !!! Foo Foo Foo !!! Please report.\n") ;
      exit (0) ;
    }
#endif

  for (j=0;j<NbLevelsToCreate;j++)
    {
      /* ON VA REGROUPER TOUTES LES TRANSITIONS DE L'ETAGE */
      NbDAGElementsToTake = 0 ;
      while (GETNEXTFILLED (Stack[SP]))
	{
	  /* CE DAGElement A SON CHAMP NEXTBASE FIXE */
	  /* DONC IL VA ETRE VIRTUELLEMENT DEPILE ET TRANSMIS A LA */
	  /* ROUTINE DE CREATION DES ETATS/TRANSITIONS */
	  NbDAGElementsToTake++ ;
	  SP-- ;
	}
      TmpBase = MakeStates (&Stack[SP+1], NbDAGElementsToTake) ;
      SETNEXTBASE (Stack[SP], TmpBase) ;
      SETNEXTFILLED (Stack[SP]) ;
    }

  return (GETNEXTBASE (Stack[SP])) ;
}
