#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "Automaton.h"
#include "CutDouble.h"
#ifdef PROTOS_NEEDED
#include "Suggest.h"
#endif



extern DAGElement *Automaton ;
extern ULONG AutomatonSize ;
extern BYTE MaxDiffLenPlus ;
extern BYTE MaxDiffLenLess ;
extern UBYTE MaxDefaultsAllowed ;
extern UBYTE MaxConsecutiveDefaults ;
extern UBYTE Buffer[MAX_WORD_LEN] ;
extern UBYTE Word[MAX_WORD_LEN] ;
extern BYTE WordLen ;
extern struct StringItem *TheWordList ;


#ifdef DEBUG
UBYTE Path[120] ;
UBYTE Letters[120] ;
UBYTE IPath=0 ;
#endif

void Suggest (Base, NbDefaults, IndexBuffer, IndexWord, NbConsecDef, LastOp, LastAffectedLetter, Check)
     ULONG Base ;
     UBYTE NbDefaults ;
     BYTE IndexBuffer ;
     BYTE IndexWord ;
     UBYTE NbConsecDef ;
     UBYTE LastOp ;
     UBYTE LastAffectedLetter ;
     ULONG Check ;

{
  ULONG i ;


  /* SI ON A DEPASSE LE NOMBRE MAX DE DEFAUT DE LETTRE, ON S'ARRETE */
  if (NbDefaults > MaxDefaultsAllowed) return ;

  if (IndexBuffer > (WordLen+MaxDiffLenPlus)) return ;

  if (Check)
    {
      /* ON REGARDE SI L'ETAT ATTEINT PRECEDEMMENT ETAIT FINAL */
      /* SI OUI, C'EST QU'ON PEUT VERIFIER SI LE MOT QU'ON AVAIT */
      /* CREE EST DIGNE D'ETRE UNE SUGGESTION */
      /* EN EFFET, ON VERIFIE MAINTENANT, LE MOT CONSTITUE DES */
      /* MODIFICATIONS PRECEDENTES. DONC ON VERIFIE AVEC "UN TOUR */
      /* DE RETARD". DONC ON VERIFIE AINSI QUE LE MOT RESULTANT DES */
      /* MODIFICATIONS VIA LES APPELS PRECEDENTS A POUR DERNIER ETAT */
      /* UN ETAT FINAL. */
      if (((WordLen-IndexBuffer) <= MaxDiffLenLess) && ((IndexBuffer-WordLen) <= MaxDiffLenPlus))
	{
	  Buffer[IndexBuffer] = '\0' ;
	  /* AVANT D'AFFICHER, ON VERIFIE SI CA N'EST PAS UN DOUBLON */
	  if (!(CutDouble (&TheWordList, Buffer)))
	    printf ("%s  ", Buffer) ;
#ifdef DEBUG
	  else
	    printf ("-Doublon-\n") ;
#endif
#ifdef DEBUG
	  Path[IPath] = '\0' ;
	  Letters[IPath] = '\0' ;
	  printf ("\t%s \t(%s)\n", Path, Letters) ;
#endif
	}
    }

  /* SI L'ETAT EST TERMINAL, ON S'ARRETE */
  if (Base == END_TRANSITION) return ;


  /* CAS DE LA LETTRE ACTUELLE BONNE */
  i = (ULONG) Word[IndexWord] ;
  if (((GETCHAR (Automaton[Base+i])) == (UBYTE) i) && (Base+i <AutomatonSize) && (Word[IndexWord] != '\0'))
    {
      Buffer[IndexBuffer] = (UBYTE) i ;

#ifdef DEBUG
      Path[IPath] = 'B' ;
      Letters[IPath] = (UBYTE) i ;
      IPath++ ;
#endif
      Suggest (GETNEXTBASE (Automaton[Base+i]), NbDefaults, IndexBuffer+1, IndexWord+1, 0, GOOD_LETTER, '\0', GETISFINAL (Automaton[Base+i])) ;
#ifdef DEBUG
      IPath-- ;
#endif
    }


  /* CAS DE LETTRE OUBLIEE */
  for (i=1;i<256;i++)
    {
      if (((GETCHAR (Automaton[Base+i]))== (UBYTE) i) && (Base+i <AutomatonSize))
	{
	  Buffer[IndexBuffer] = (UBYTE) i ;

	  if ((UBYTE) i != Word[IndexWord])
	    {
#ifdef DEBUG
	      Path[IPath] = 'O' ;
	      Letters[IPath] = (UBYTE) i ;
	      IPath++ ;
#endif

	      if (LastOp == EXCEDENT_LETTER)
		{
		  if (((UBYTE)i) != LastAffectedLetter)
		    Suggest (GETNEXTBASE (Automaton[Base+i]), NbDefaults, IndexBuffer+1, IndexWord, 0, FORGOTTEN_LETTER, (UBYTE)i, GETISFINAL (Automaton[Base+i])) ;
		}
	      else
		Suggest (GETNEXTBASE (Automaton[Base+i]), NbDefaults+1, IndexBuffer+1, IndexWord, NbConsecDef+1, FORGOTTEN_LETTER, (UBYTE)i, GETISFINAL (Automaton[Base+i])) ;
#ifdef DEBUG
	      IPath-- ;
#endif
	    }
	}
    }


  /* CAS D'UNE LETTRE EN TROP */
  if ((LastOp != FORGOTTEN_LETTER) && (Word[IndexWord] != '\0'))
    {
#ifdef DEBUG
      Path[IPath] = 'T' ;
      Letters[IPath] = (UBYTE) Word[IndexWord] ;
      IPath++ ;
#endif
      Suggest (Base, NbDefaults+1, IndexBuffer, IndexWord+1, NbConsecDef+1, EXCEDENT_LETTER, Word[IndexWord], FALSE) ;
#ifdef DEBUG
      IPath-- ;
#endif
    }
}


/* GETISFINAL (Automaton[Base+i]) */


