#include <stdio.h>
#include <stdlib.h>
#include "Automaton.h"

#ifdef PROTOS_NEEDED
#include "Prototypes.h"
#endif


DAGElement *Automaton=NULL ;
ULONG AutomatonSize ;




void main (argc, argv)
     int argc ;
     char *argv[] ;

{
  FILE *DagFile ;
  ULONG InitialState ;
  UBYTE WordBuffer[MAX_WORD_LEN] ;
  UBYTE SecondBuffer[MAX_WORD_LEN] ;
  ULONG Magic ;

  printf ("CrossCheat by Franois PESSAUX (c) 1995.\n") ;
  if (argc != 2)
    {
      /* ERREUR DE PARAMETRES */
      printf ("Parameter error. Usage: CrossCheat <Dag>.\n") ;
      printf ("CrossCheat is a crosswords cheater. Give it the pattern ") ;
      printf ("you want to fill (with * for unknown letter), and it'll ") ;
      printf ("gives all matching words of the dictionary database.\n") ;
      exit (1) ;
    }

  DagFile = (FILE*) fopen (argv[1], "r") ;
  if (DagFile == NULL)
    {
      /* OUVERTURE FOIREE */
      printf ("Unable to open the dictionary database '%s'.\n", argv[1]) ;
      exit (0) ;
    }

  /* IS THERE MAGIC TAG ? */
  fread (&Magic, 1, sizeof (ULONG), DagFile) ;
  if (Magic != TABLEMAGICNUMBER)
    {
      printf ("Format error. '%s' isn't a dictionary database.\n", argv[1]) ;
      fclose (DagFile) ;
      exit (0) ;
    }


  /* WE'RE TO READ THE AUTOMATON'S >DATA< SIZE */
  /* THAT'S TO SAY THIS SIZE DO NOT INCLUDE THE 2 ULONGS: INITIAL STATE */
  /* AND AUTOMATON SIZE */
  fread (&AutomatonSize, 1, sizeof (ULONG), DagFile) ;

  /* LECTURE DE L'ETAT INITIAL DE L'AUTOMATE */
  fread (&InitialState, 1, sizeof (ULONG), DagFile) ;

  /* ALLOCATION DE LA MEMOIRE NECESSAIRE POUR LE STOCKER EN MEMOIRE CENTRALE */
  Automaton = (DAGElement*) malloc (AutomatonSize*sizeof (DAGElement)) ;
  if (Automaton == NULL)
    {
      /* ALLOCATION FOIREE */
      printf ("Insufficient memory.\n") ;
      printf ("Requiered memory space : %ld bytes.\n",
                               (AutomatonSize*sizeof (DAGElement))) ;
      fclose (DagFile) ;
      exit (0) ;
    }

  /* LECTURE DES DONNEES DE L'AUTOMATE */
  fread (Automaton, AutomatonSize, sizeof (DAGElement), DagFile) ;
  /* ON N'A PLUS BESOIN DU FICHIER, DONC ON LE FERME */
  fclose (DagFile) ;

  printf ("Pattern : ") ;
  scanf ("%s", WordBuffer) ;
  while (!feof (stdin))
    {
      if (strcmp (WordBuffer, "fin") == 0)
	break ;
      MatchWord (WordBuffer, SecondBuffer, 0, 0, InitialState) ;
      printf ("Pattern : ") ;
      scanf ("%s", WordBuffer) ;
    }

  /* ON REND LA MEMOIRE AU SYSTEME */
  free (Automaton) ;
  printf ("\n") ;
  exit (0) ;
}
